<template>
  <button @click="throwError">Throw error</button>

  <div class="form-container">
    <h2>Login</h2>
    <form @submit.prevent="submitForm">
      <div v-if="errorMessage" class="error-message">{{ errorMessage }}</div>

      <div class="form-group">
        <label for="username">Username:</label>
        <input type="text" id="username" v-model="username" required />
      </div>
      <div class="form-group">
        <label for="password">Password:</label>
        <input type="password" id="password" v-model="password" required />
      </div>
      <div class="button-container">
        <button class="register" @click="goToRegister">Register</button>
        <button type="submit">Login</button>
      </div>
    </form>
  </div>
</template>


<script>
import axios from 'axios';
import { useRouter } from 'vue-router'; // Importa useRouter

export default {
  data() {
    return {
      username: "",
      password: "",
      errorMessage: '', // Agrega esta línea
    };
  },
  setup() {
    const router = useRouter(); // Instancia el router
    return { router };
  },
  methods: {
    throwError() {
      throw new Error('Sentry Error');
    },
    async submitForm() {
      try {
        const response = await axios.post('http://18.100.253.149:9000/login', {
          username: this.username,
          password: this.password,
        });
        console.log(response.data);
        if (response.data.token) {
          localStorage.setItem('accessToken', response.data.token);
          this.router.push('/tasks'); // Redirige al usuario a la vista TasksList
        }
        // Realiza acciones adicionales según la respuesta del servidor, como guardar tokens o redirigir a otra página.
      } catch (error) {
        console.error(error);
        if (error.response && error.response.status === 401) {
          this.errorMessage = 'Usuario o contraseña incorrecto';
        } else {
          console.error(error);
        }
      }
    },
    goToRegister() {
      this.$router.push({ name: "register" });
    }
  }
};
</script>

<style scoped>
.form-container {
  max-width: 400px;
  margin: 0 auto;
  padding: 1rem;
  background-color: #fff;
  border-radius: 5px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
}

h2 {
  text-align: center;
  margin-bottom: 1rem;
}

.form-group {
  display: flex;
  flex-direction: column;
  margin-bottom: 1rem;
}

label {
  margin-bottom: 0.5rem;
}

input {
  padding: 0.5rem;
  font-size: 1rem;
}

button {
  padding: 0.5rem 1rem;
  font-size: 1rem;
  background-color: #007bff;
  color: #fff;
  border: none;
  border-radius: 5px;
  cursor: pointer;
  margin-top: 1rem;
}

button:hover {
  background-color: #0056b3;
}
.button-container {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-top: 1rem;
}

button.register {
  background-color: #fff;
  color: #007bff;
}

button.register:hover {
  background-color: #f0f0f0;
}

.error-message {
  color: red;
  font-weight: bold;
  margin-top: 1rem;
}
</style>
